<template>
  <div v-if="!account" class="spinner">
    <img src="/resources/img/loading.svg" alt="loading"/>
  </div>
 
  <div v-else>
    <v-toolbar color="primary" dark dense fixed app flat  scroll-off-screen>
        <v-toolbar-side-icon @click.stop="drawer = !drawer"></v-toolbar-side-icon>
         <v-toolbar-title>
            <v-breadcrumbs dark :items="breadcrumbItems" divider=">" class="cursive breadcrumb" />
        </v-toolbar-title>
    </v-toolbar>

    <NavDrawer :drawer="drawer" @update="drawer = $event" />

     <v-content dark>
        <v-layout row wrap>
            <v-flex xs12 md8 offset-md2 >
                <v-card>
                    <v-card-title class="subheading">
                        <v-layout>
                            <v-flex xs10>
                                <v-avatar slot="activator" size="36px">
                                  <img v-if="profile.picture" :src="profile.picture" alt="Avatar">
                                  <v-icon v-else large color="primary">face</v-icon>
                                </v-avatar>
                                <span class="ml-2">{{profile.name}}</span>
                            </v-flex>
                            <v-flex xs2 class="text-xs-right">
                                <v-icon small disabled>settings</v-icon>
                            </v-flex>
                        </v-layout>
                    </v-card-title>
                    <v-card-text>
                        <v-layout row wrap>
                            <v-flex xs12 sm3 :class="keyClass">{{$i18n.t("account.email")}}</v-flex>
                            <v-flex xs12 sm9 :class="valueClass">{{profile.email}}</v-flex>
                            
                            <v-flex xs12 sm3 :class="keyClass">{{$i18n.t("account.subscription")}}</v-flex>
                            <v-flex xs12 sm9 :class="valueClass"> 
                                <v-layout row wrap>
                                    <v-flex xs8 sm10>
                                        <span v-if="!!account">{{account.plan}}</span>
                                    </v-flex>
                                    <v-flex xs4 sm2 class="text-xs-right">
                                        <span v-if="!!account" class="account-action caption pl-2 pr-2 pa-1" ><strong>{{$i18n.t("account.actions.upgrade")}}</strong></span>
                                    </v-flex>
                                </v-layout>
                            </v-flex>
                            
                            <v-flex v-if="usage && subscription" xs12 sm3 :class="keyClass">{{$i18n.t("account.usage.title")}}</v-flex>
                            <v-flex v-if="usage && subscription" xs12 sm9 :class="valueClass">
                                <v-layout row wrap>
                                    <v-flex xs9>
                                        {{ $i18n.t("account.usage.scopes") }}
                                    </v-flex> 
                                    <v-flex xs3 class="text-xs-right">
                                        {{ $i18n.t("account.usage.count", { count: usage.length, max: subscription.scopes }) }}
                                    </v-flex>
                                    <v-flex xs9>
                                        {{ $i18n.t("account.usage.applications") }} 
                                    </v-flex>
                                    <v-flex xs3 class="text-xs-right">
                                        {{ $i18n.t("account.usage.count", { count: usage.reduce((accu, val) => accu + val.count, 0), max: subscription.applications }) }}
                                    </v-flex>
                                </v-layout>
                            </v-flex>
                            
                            <v-flex xs12 sm3 :class="keyClassLast">{{$i18n.t("account.expires")}}</v-flex>
                            <v-flex xs12 sm9 :class="valueClass + ' last pb-3 mb-3'">
                                <v-layout row wrap>
                                    <v-flex xs8 sm10>
                                        <span v-if="account">{{expires}}</span>
                                    </v-flex>
                                    <v-flex xs4 sm2 class="text-xs-right">
                                        <span v-if="account" class="account-action caption pl-2 pr-2 pa-1" >{{$i18n.t("account.actions.extend")}}</span>
                                    </v-flex>
                                </v-layout>
                            </v-flex>
                            
                            <v-flex xs12 class="caption text-xs-center mt-3 pa-4 danger-zone">
                                <div class="mb-2">
                                        {{$i18n.t("account.actions.delete.warning")}}
                                </div>
                                <div class="caption mb-3" style="color: red">
                                    <v-layout row dense>
                                        <v-flex xs12 sm8 offset-sm2>
                                            <v-text-field
                                                v-model="verifyEmail"
                                                browser-autocomplete="off"
                                                :rules="verifyRule"
                                                :label="$i18n.t('account.actions.delete.verify.text')"
                                            ></v-text-field>
                                        </v-flex>
                                    </v-layout>
                                </div>
                                <v-btn color="red" :dark="profile && verifyEmail == profile.email"
                                    :disabled="!profile || verifyEmail != profile.email" 
                                    @click="deleteAccount">
                                    <v-icon small>delete</v-icon>
                                    <span>&nbsp; {{$i18n.t("account.actions.delete.text")}} </span>
                                </v-btn>
                            </v-flex>
                        </v-layout>
                    </v-card-text>
                </v-card>
            </v-flex>
        </v-layout>
    </v-content>
    
    <v-dialog v-model="expiredDialog" max-width="420px" persistent>
        <v-card>
            <v-card-title class="subheading">
                <span class="ml-2">{{$i18n.t("account.expired.title")}}</span>
            </v-card-title>
            <v-divider/>
            <v-card-text>
                <div v-if="!!account" class="pa-2">
                    {{$i18n.t("account.expired.description", { expires })}}
                </div>
            </v-card-text>
            <v-card-actions>
                <v-btn flat color="primary">{{$i18n.t("account.actions.extend")}}</v-btn>
                <v-btn flat color="primary" @click="dialog = !dialog">{{$i18n.t("common.close")}}</v-btn>
            </v-card-actions>
        </v-card>
    </v-dialog>
  </div>
</template>

<script>
import moment from 'moment'
import Account from '../auth/Account' 
import NavDrawer from '../components/NavDrawer'
import config from '../pijam.config.js'
export default {
    name: 'Profile',
    components: { NavDrawer },
    activeTab: null,
    data() {
        return {
            verifyEmail: null,
            drawer: null,
            expired: false,
            account: null,
            profile: { },
            activeTab: null,
            dialog: null,
            usage: null,
            plans: config.plans
        }
    },
    mounted() {
        this.profile = JSON.parse(localStorage.getItem('user'))
        this.loadAccount()
        this.loadUsage()
    },
    computed: {
        breadcrumbItems() {
           return [
             {
               text: this.$i18n.t("account.title"),
               disabled: true
             }
           ]
        },
        subscription() {
            if ( this.account ) {
                return this.plans[this.account.plan.toLowerCase()]
            }
            else {
                return null
            }
        },
        verifyRule() {
            return [v => !!v && v == this.profile.email || this.$i18n.t("account.actions.delete.verify.rule")]
        },
        expiredDialog: {
            get() {
                return this.dialog == null ? this.expired : this.dialog
            },
            set(v) {
                this.dialog = v
            }
        },
        expires() {
            return moment(this.account.expires).format(this.$i18n.t("common.dateFormat"))
        },
        valueClass() {
            return 'body-1 cell ' + (this.$vuetify.breakpoint.xs === true ? ' value-cell-xs' :  ' pt-3 mt-3 pl-3')
        },
        keyClass() {
            return 'key pt-3 mt-3 cell ' + (this.$vuetify.breakpoint.xs === true ? ' key-cell-xs' : '')
        },
        keyClassLast() {
            return this.keyClass + ' last ' + (this.$vuetify.breakpoint.xs === true ? '' : 'pb-3 mb-3')
        }
    },
    methods: {
        async deleteAccount() {
            if ( this.verifyEmail == this.profile.email ) {
                await this.$api.deleteUser()
                this.logout()
            }
        },
        async loadAccount() {
            this.user = Object.assign(this.profile, { })
            const user = await this.$api.getUser()
            this.account = new Account(user)
            this.expired = this.account.isExpired()
            this.user = Object.assign(this.profile, this.account)
        },
        async loadUsage() {
            this.$api.getUsage().then((usage) => {
                this.usage = usage 
            })
        }
    }
}
</script>

<style>
.cell {
  border-top: 1px #ccc solid;
}
.cell.last {
  border-bottom: 1px #ccc solid;
}
.value-cell-xs {
  border-top: none !important;  
}
.key-cell-xs.last {
  border-bottom: none !important;
}
.key {
  text-transform: uppercase;
  color: #2196F3;
  font-weight: bold;
}
.danger-zone {
  border: 1px #ccc solid;
  border-radius: 4px;
}
.account-action {
  background-color: orange; 
  font-weight: bold !important;  
  color: white; 
  border-radius: 10px;
  /* hide those actions during the mvp phase */
  display: none; 
}
</style>






